package com.yaohun.aurechargedata;

import com.yaohun.aurechargedata.api.RechargeAPI;
import com.yaohun.aurechargedata.manage.RechargeManage;
import com.yaohun.aurechargedata.util.TimeType;
import me.clip.placeholderapi.expansion.PlaceholderExpansion;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;

import java.util.HashMap;

/**
 * @Author: Baka
 * @Date: 2019/12/23 13:20
 */
public class RechargeExpansion extends PlaceholderExpansion {
    private Plugin plugin;

    public RechargeExpansion(Plugin plugin) {
        this.plugin = plugin;
    }

    @Override
    public boolean persist() {
        return true;
    }

    @Override
    public boolean canRegister() {
        return true;
    }

    @Override
    public String getAuthor() {
        return plugin.getDescription().getAuthors().toString();
    }

    @Override
    public String getIdentifier() {
        return "aurecharge";
    }

    @Override
    public String getVersion() {
        return plugin.getDescription().getVersion();
    }

    @Override
    public String onPlaceholderRequest(Player player, String identifier) {
        if (identifier.equalsIgnoreCase("day")) {
            String playerName = player.getName();
            int val = RechargeAPI.getRechargeData(playerName, TimeType.Daily);
            return String.valueOf(val);
        }else if (identifier.equalsIgnoreCase("month")) {
            String playerName = player.getName();
            int val = RechargeAPI.getRechargeData(playerName, TimeType.Monthly);
            return String.valueOf(val);
        }else if (identifier.equalsIgnoreCase("me")) {
            String playerName = player.getName();
            int val = RechargeAPI.getRechargeData(playerName, TimeType.Annual);
            return String.valueOf(val);
        }  else {
            String[] sp = identifier.split("_");
            // %recharge_1_name%
            // %recharge_1_value%
            if (sp.length == 2) {
                int num = Integer.parseInt(sp[0]);
                RechargeManage manage = Main.rechargeManage;
                return manage.getRankingPlayer(num, sp[1]);
            }
        }
        return null;
    }
}