package com.yaohun.aurechargedata.cmd;

import com.yaohun.aurechargedata.Main;
import com.yaohun.aurechargedata.api.RechargeAPI;
import com.yaohun.aurechargedata.event.RechargeEvent;
import com.yaohun.aurechargedata.manage.RechargeManage;
import com.yaohun.aurechargedata.util.TimeType;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;
import org.bukkit.entity.HumanEntity;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class MainCmd implements CommandExecutor , TabCompleter {
    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if(!sender.isOp()){return true;}
        if(args.length == 0){
            sender.sendMessage("§r");
            sender.sendMessage("§e------- ======= §6充值数据统计 §e======= -------");
            sender.sendMessage("§2/apay look §e[玩家] §f- §2查询插件数据");
            sender.sendMessage("§2/apay give §e[玩家] §2<金额> §f- §2增加累积§f(日、月、年)");
            sender.sendMessage("§2/apay givemonth §e[玩家] §2<金额> §f- §2增加累积§f(月、年)");
            sender.sendMessage("§2/apay giveannual §e[玩家] §2<金额> §f- §2增加累积§f(年)");
            sender.sendMessage("§e------- ======= §6充值数据统计 §e======= -------");
            sender.sendMessage("§r");
            return true;
        }
        if(args.length == 1 && args[0].equalsIgnoreCase("rank")){
            Main.rechargeManage.upDataMonthlyRechargesTop();
            sender.sendMessage("§f[§c消息§f] §a累计充值月排行榜已刷新.");
            return true;
        }
        if(args.length == 1 && args[0].equalsIgnoreCase("top")){
            RechargeManage manage = Main.rechargeManage;
            sender.sendMessage("§f[§c消息§f] §a正在查看累积充值月排行榜.");
            sender.sendMessage("第一名: "+manage.getRankingPlayer(1,"name")+"  金额: "+manage.getRankingPlayer(1,"value"));
            sender.sendMessage("第二名: "+manage.getRankingPlayer(2,"name")+"  金额: "+manage.getRankingPlayer(2,"value"));
            sender.sendMessage("第三名: "+manage.getRankingPlayer(3,"name")+"  金额: "+manage.getRankingPlayer(3,"value"));
            sender.sendMessage("第四名: "+manage.getRankingPlayer(4,"name")+"  金额: "+manage.getRankingPlayer(4,"value"));
            sender.sendMessage("第五名: "+manage.getRankingPlayer(5,"name")+"  金额: "+manage.getRankingPlayer(5,"value"));
            return true;
        }
        if(args.length == 2 && args[0].equalsIgnoreCase("look")){
            String playName = args[1];
            sender.sendMessage("§f[§c消息§f] §a玩家充值信息查询:");
            sender.sendMessage("§a玩家名称§f: §6"+playName);
            sender.sendMessage("§a本月充值§f: §e"+RechargeAPI.getRechargeData(playName,TimeType.Monthly)+"元");
            sender.sendMessage("§a累计充值§f: §e"+RechargeAPI.getRechargeData(playName,TimeType.Annual)+"元");
            sender.sendMessage("§a累计消费§f: §b0软");
            sender.sendMessage("§a最后一次充值§f: §d"+RechargeAPI.getRechargePlayer(playName).getLastOperationShow());
            return true;
        }
        if(args.length == 3){
            // 获取指定参数
            String giveType = args[0];  // 操作类型（give, givemonth, giveannual）
            String playerName = args[1];  // 玩家名字
            // 判断并转换第三个参数为整数
            int amount;
            try {
                amount = Integer.parseInt(args[2]);  // 尝试将第三个参数转换为整数
            } catch (NumberFormatException e) {
                // 如果无法转换为整数，可以进行错误处理或日志记录
                Bukkit.getConsoleSender().sendMessage("[日志-错误-AuRechargeData] args[2] 无法转换为整数.");
                return true;
            }
            // 根据操作类型执行相应的充值操作
            if (giveType.equalsIgnoreCase("cz")) {
                // 执行每日、每月和年度充值操作，默认为每日
                RechargeAPI.addRechargeData(playerName, amount);
                int setVal = RechargeAPI.getRechargeData(playerName,TimeType.Daily);
                sender.sendMessage("§7[§6累积充值§7] §f已增加 §6" + playerName + " §f每日 §b" + amount + "累计  §f已累积充值: §e" + setVal);
                RechargeEvent rechargeEvent = new RechargeEvent(playerName,amount);
                Bukkit.getPluginManager().callEvent(rechargeEvent);
            } else if (giveType.equalsIgnoreCase("give")) {
                // 执行每日、每月和年度充值操作，默认为每日
                RechargeAPI.addRechargeData(playerName, amount);
                int setVal = RechargeAPI.getRechargeData(playerName,TimeType.Daily);
                sender.sendMessage("§7[§6累积充值§7] §f已增加 §6" + playerName + " §f每日 §b" + amount + "累计  §f已累积充值: §e" + setVal);
            } else if (giveType.equalsIgnoreCase("givemonth")) {
                // 执行每月充值操作
                RechargeAPI.addRechargeData(playerName, amount, TimeType.Monthly);
                int setVal = RechargeAPI.getRechargeData(playerName,TimeType.Monthly);
                sender.sendMessage("§7[§6累积充值§7] §f已增加 §6" + playerName + " §f每月 §b" + amount + "累计  §f已累积充值: §e" + setVal);
            } else if (giveType.equalsIgnoreCase("giveannual")) {
                // 执行年度充值操作
                RechargeAPI.addRechargeData(playerName, amount, TimeType.Annual);
                int setVal = RechargeAPI.getRechargeData(playerName,TimeType.Annual);
                sender.sendMessage("§7[§6累积充值§7] §f已增加 §6" + playerName + " §f永久 §b" + amount + "累计  §f已累积充值: §e" + setVal);
            } else if (giveType.equalsIgnoreCase("take")) {
                RechargeAPI.takeRechargeData(playerName,amount);
                int setVal = RechargeAPI.getRechargeData(playerName,TimeType.Annual);
                sender.sendMessage("§7[§6累积充值§7] §f已扣除 §6" + playerName + " §f永久 §c-" + amount + "累计  §f已累积充值: §e" + setVal);
            }
        }
        return false;
    }

    @Override
    public List<String> onTabComplete(CommandSender sender, Command command, String label, String[] args) {
        List<String> completions = new ArrayList<>();
        if(args.length == 1){
            completions.add("cz");
            completions.add("give");
            completions.add("givemonth");
            completions.add("giveannual");
            completions.add("take");
        }else if(args.length == 2){
            // 获取全服在线玩家名字数组
            String[] onlinePlayers = Bukkit.getOnlinePlayers().stream().map(HumanEntity::getName).toArray(String[]::new);
            completions.addAll(Arrays.asList(onlinePlayers));
        }else if(args.length == 3){
            completions.add("5");
            completions.add("10");
            completions.add("30");
            completions.add("50");
            completions.add("100");
            completions.add("300");
            completions.add("500");
            completions.add("980");
            completions.add("128");
        }
        return completions;
    }
}
